import usb
import os
import time
from time import sleep

####################################

VENDOR_RQ_GET_SWITCH1 = 0
VENDOR_RQ_GET_SWITCH2 = 1
VENDOR_RQ_GET_SOUND1  = 2
VENDOR_RQ_GET_SOUND2  = 3
VENDOR_RQ_SET_LED     = 4

####################################
class Board:
    def __init__(self):
        #print "Looking for MCU board..."
        dev = self.find_board()
        if not dev: raise "MCU board not found!"
        #print "MCU board found"
        self.handle = dev.open()

    def find_board(self):
        for bus in usb.busses():
            for dev in bus.devices:
                if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                    return dev
        return None

    def set_led(self,pin,val):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
        self.handle.controlMsg(reqType, VENDOR_RQ_SET_LED, None, value=val*256+pin)

    def get_switch1(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH1, 1)
        return buf[0]

    def get_switch2(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH2, 1)
        return buf[0]

    def get_sound1(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf2 = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SOUND1, 2)
        return buf2[0] + buf2[1]*256
    
    def get_sound2(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf2 = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SOUND2, 2)
        return buf2[0] + buf2[1]*256


def compare():
	if count2 < count1 :
		print "\nThe Result is: Player 1 is winner "
		for i in range(20):		
			b.set_led(0,0)
			b.set_led(1,0)
			b.set_led(2,0)
			sleep(0.1)
			b.set_led(0,1)
			b.set_led(1,1)
			b.set_led(2,1)
			sleep(0.1)
		b.set_led(3,0)
		b.set_led(4,0)
		b.set_led(5,0)
	elif count1 < count2 :
		print "\nThe Result is: Player 2 is winner"
		for j in range(20):		
			b.set_led(3,0)
			b.set_led(4,0)
			b.set_led(5,0)
			sleep(0.1)
			b.set_led(3,1)
			b.set_led(4,1)
			b.set_led(5,1)
			sleep(0.1)
		b.set_led(0,0)
		b.set_led(1,0)
		b.set_led(2,0)
	else :
		print "\nThe Result is: Tie"


b = Board()
state =-1 


KEYS = ['xte "keydown Up"','xte "keydown Down"']
KEYS2 = ['xte "keyup Up"','xte "keyup Down"']


print "\nPlease select game"
print "push switch1 or switch2 or both in the same time for quit the program"
while(1):
	if b.get_switch1() == 1:
		state = 0
		count1 = 0
		count2 = 0
		n=0
	if b.get_switch2() == 1:
		state = 1
		sound01 = 0
		sound02 = 0
	if b.get_switch1() == 1 and b.get_switch2() == 1 :
		break

	if(state == 0):
		if b.get_switch1() == 1:
			b.set_led(0,0)
			b.set_led(1,0)
			b.set_led(2,0)
			b.set_led(3,0)
			b.set_led(4,0)
			b.set_led(5,0)
			print "\nhow long? : ",
			n = int(raw_input())
			print "\nStart Game 1 !!\n"	
		
			for x in range(n): 
				sound1=b.get_sound1()
				sound2=b.get_sound2()
		
	
				if sound1 < 100 and sound2 < 100:
					print "it's a tie"
	
				elif sound1 >= 100 and sound2 < 100:
					print "player 1 win !"
					count1+=1
	
				elif sound1 < 100 and sound2 >= 100:
					print "player 2 win !"
					count2+=1
				else:
					print "it's a tie"	
	
		
				if sound1 < 100 :
					b.set_led(0,0)
					b.set_led(1,0)
					b.set_led(2,0)
					sleep (0.05)	
				if sound1 >= 100 :
					b.set_led(0,1)
					sleep (0.05)	
					if sound1 > 399 :
						b.set_led(1,1)
						sleep (0.05)	
						if sound1 > 799 :  
							b.set_led(2,1)
							sleep (0.05)	
		
				if sound2 < 100 :
					b.set_led(3,0)
					b.set_led(4,0)
					b.set_led(5,0)
					sleep (0.05)	
				if sound2 >= 100 :
					b.set_led(3,1)
					sleep (0.05)	
					if sound2 > 399 :
						b.set_led(4,1)
						sleep (0.05)	
						if sound2 > 799 :
							b.set_led(5,1)
							sleep (0.05)	 
	
			compare()
			print "by score " + str(count1)+ ' : ' + str(count2)

	if state == 1:
		b.set_led(0,0)
		b.set_led(1,0)
		b.set_led(2,0)
		b.set_led(3,0)
		b.set_led(4,0)
		b.set_led(5,0)
		sound01 = b.get_sound1()
		sound02 = b.get_sound2()
		if 	sound01 >= 800 :		
			while sound01 >= 800 :     # sound1 for get down 					
				sound01 = b.get_sound1()
				os.system(KEYS[1])
				b.set_led(0,1)
				b.set_led(1,1)
				b.set_led(2,1)
				b.set_led(3,0)
				b.set_led(4,0)
				b.set_led(5,0)
				sleep(0.1)	
			os.system(KEYS2[1])
	
		if 	sound02 >= 800 :		
			while sound02 >= 800 :     # sound2 for get up				
				sound02 = b.get_sound2()
				os.system(KEYS[0])
				b.set_led(0,0)
				b.set_led(1,0)
				b.set_led(2,0)
				b.set_led(3,1)
				b.set_led(4,1)
				b.set_led(5,1)
				sleep(0.1)	
			os.system(KEYS2[0])
				 
		
